## START: Set by rpmautospec
## (rpmautospec version 0.6.5)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 1;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

# Generated by rust2rpm 27
%bcond check 1

%global crate sequoia-sq

%if 0%{?rhel}
%global __brp_mangle_shebangs_exclude_from ^/usr/src/debug/.*$
%endif


Name:           rust-sequoia-sq
Version:        1.3.1.1
Release:        %autorelease
Summary:        Command-line frontends for Sequoia

License:        LGPL-2.0-or-later
URL:            https://crates.io/crates/sequoia-sq
# The version 1.3.1 upstream + patches from justus/pqc branch
# Generated using:
#  git archive --format=tar.gz --prefix sequoia-sq-1.3.1.1/ -o sequoia-sq-1.3.1.1.tar.gz justus/pqc
Source0:        %{crate}-%{version}.tar.gz

# Generated using cargo-vendor-filterer:
#   cargo vendor-filterer --platform x86_64-unknown-linux-gnu \
#                         --platform powerpc64le-unknown-linux-gnu \
#                         --platform aarch64-unknown-linux-gnu \
#                         --platform i686-unknown-linux-gnu \
#                         --platform s390x-unknown-linux-gnu \
#                         --all-features
#   tar -czf ../%%{crate}-vendor-%%{version}.tar.gz vendor
Source1:        %{crate}-vendor-%{version}.tar.gz
Source2:        capnproto-c++-1.0.1.tar.gz
Source3:        vendor.toml
# Manually created patch for downstream crate metadata changes
# * switch crypto backend from Nettle to OpenSSL
# * exclude files that are only useful for upstream development
# * drop automated generation of upstream integration tests
# * drop features for unsupported crypto backends
Patch:          sequoia-sq-fix-metadata.diff

%if 0%{?rhel}
BuildRequires:  rust-toolset
%else
BuildRequires:  cargo-rpm-macros >= 24
%endif

# vendored openssl-sys
BuildRequires:  openssl-devel
# vendored rustqlite
BuildRequires:  sqlite-devel

BuildRequires:  gcc-c++
BuildRequires:  cmake >= 3.1

%global _description %{expand:
Command-line frontends for Sequoia.}

%description %{_description}

%package     -n %{crate}
Summary:        %{summary}
# (Apache-2.0 OR MIT) AND BSD-3-Clause
# (MIT OR Apache-2.0) AND Unicode-DFS-2016
# 0BSD OR MIT OR Apache-2.0
# Apache-2.0
# Apache-2.0 AND MIT
# Apache-2.0 OR BSL-1.0
# Apache-2.0 OR ISC OR MIT
# Apache-2.0 OR MIT
# Apache-2.0 WITH LLVM-exception OR Apache-2.0 OR MIT
# BSD-2-Clause OR Apache-2.0 OR MIT
# BSD-3-Clause
# BSL-1.0
# LGPL-2.0-or-later
# MIT
# MIT OR Apache-2.0
# MIT OR Apache-2.0 OR Zlib
# MIT OR Zlib OR Apache-2.0
# MPL-2.0
# Unlicense OR MIT
# Zlib OR Apache-2.0 OR MIT
License:        %{shrink:
    LGPL-2.0-or-later AND
    Apache-2.0 AND
    BSL-1.0 AND
    BSD-3-Clause AND
    MIT AND
    MPL-2.0 AND
    Unicode-DFS-2016 AND
    (0BSD OR MIT OR Apache-2.0) AND
    (Apache-2.0 OR BSL-1.0) AND
    (Apache-2.0 OR ISC OR MIT) AND
    (Apache-2.0 OR MIT) AND
    (Apache-2.0 WITH LLVM-exception OR Apache-2.0 OR MIT) AND
    (MIT OR Apache-2.0 OR Zlib) AND
    (Unlicense OR MIT)
}
# LICENSE.dependencies contains a full license breakdown

%description -n %{crate} %{_description}

%files       -n %{crate}
%license LICENSE.txt
%license LICENSE.dependencies
%license cargo-vendor.txt
%doc README.md
%{_bindir}/sq
%{_mandir}/man1/sq*
%if 0%{?rhel} > 9
%{bash_completions_dir}/sq.bash
%{fish_completions_dir}/sq.fish
%{zsh_completions_dir}/_sq
%endif

%prep
%autosetup -n %{crate}-%{version} -N -a1
%autopatch -M 99 -p1
%cargo_prep -N
# include full configuration for vendored dependencies
cat %{SOURCE3} >> .cargo/config.toml

# drop broken integration tests
rm -vr subplot/
rm -v tests/sq-subplot.rs

mkdir -p bundled_capnproto
pushd bundled_capnproto
tar --strip-components=1 -xf %{SOURCE2}
popd

%build
export ASSET_OUT_DIR=target/assets
pushd bundled_capnproto
%cmake -DBUILD_TESTING=OFF
%cmake_build
export PATH="$PWD/%{__cmake_builddir}/src/capnp:$PATH"
popd

%cargo_build
%{cargo_license_summary}
%{cargo_license} > LICENSE.dependencies
%{cargo_vendor_manifest}
# replace un-parseable git snapshot dependency information
sed 's/\(.*\) (.*#\(.*\))/\1+git\2/' -i cargo-vendor.txt

%install
# for some reason, cargo install does not work
# with vendored dependncies from git branch
#%%cargo_install
install -Dpm 0755 target/rpm/sq -t %{buildroot}/%{_bindir}
# install manual pages
mkdir -p %{buildroot}/%{_mandir}/man1
cp -pav target/assets/man-pages/sq*.1 %{buildroot}/%{_mandir}/man1/
%if 0%{?rhel} > 9
# install shell completions
install -Dpm 0644 target/assets/shell-completions/sq.bash \
    %{buildroot}/%{bash_completions_dir}/sq.bash
install -Dpm 0644 target/assets/shell-completions/sq.fish \
    %{buildroot}/%{fish_completions_dir}/sq.fish
install -Dpm 0644 target/assets/shell-completions/_sq \
    %{buildroot}/%{zsh_completions_dir}/_sq
%endif


%if %{with check}
%check
%cargo_test
%endif

%changelog
## START: Generated by rpmautospec
* Fri Jul 04 2025 Jakub Jelen <jjelen@redhat.com> - 1.3.1.1-1
- Pull PQC crypto to sq

* Thu Mar 27 2025 Jakub Jelen <jjelen@redhat.com> - 1.3.0-2
- Make installation of shell completions and man pages more robust

* Wed Mar 19 2025 Jakub Jelen <jjelen@redhat.com> - 1.3.0-1
- Update to 1.3.0

* Tue Jan 14 2025 Fabio Valentini <decathorpe@gmail.com> - 1.1.0-2
- Stop skipping tests that no longer need to be skipped

* Mon Jan 06 2025 Daiki Ueno <dueno@redhat.com> - 1.1.0-1
- Update to 1.1.0 upstream release

* Tue Oct 29 2024 Troy Dawson <tdawson@redhat.com> - 0.37.0-5
- Bump release for October 2024 mass rebuild:

* Mon Aug 26 2024 Daiki Ueno <dueno@redhat.com> - 0.37.0-4
- Update vendored openssl, sequoia-openpgp and zerovec crates

* Thu Aug 22 2024 Stanislav Zidek <szidek@redhat.com> - 0.37.0-3
- initial CI and gating setup

* Tue Aug 20 2024 Daiki Ueno <dueno@redhat.com> - 0.37.0-2
- Don't compile capnproto in %%prep

* Tue Feb 15 2022 Zbigniew Jędrzejewski-Szmek <zbyszek@in.waw.pl> - 0.25.0-5
- Rebuild with package notes

* Fri Jan 21 2022 Fedora Release Engineering <releng@fedoraproject.org> - 0.25.0-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_36_Mass_Rebuild

* Tue Sep 14 2021 Sahana Prasad <sahana@redhat.com> - 0.25.0-3
- Rebuilt with OpenSSL 3.0.0

* Fri Jul 23 2021 Fedora Release Engineering <releng@fedoraproject.org> - 0.25.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_35_Mass_Rebuild

* Thu Apr 08 2021 Fabio Valentini <decathorpe@gmail.com> - 0.25.0-1
- Initial package

## END: Generated by rpmautospec
